/*
 * Person.java
 *
 * Created on 9. Mai 2002, 16:30
 */

package gpa;

/**
 *
 * @author  andreas
 */
public class Person extends Objekt {
    
    /** Creates a new instance of Person */
    public Person(int p_nummer) {
        super(p_nummer,false);
        antworten = new String[4];
        ppdr = new String[4];
        pmdr = new String[4];
        ipdr = new String[4];
        imdr = new String[4];
        aendertpersonenfeld = new boolean[4];
        aendertinventarfeld = new boolean[4];
        werteEinlesen();
        attributeEinlesen();
    }
    
    private boolean interaktivvar;
    private String antwort;
    private String[] antworten;
    private String[] ppdr;
    private String[] pmdr;
    private String[] ipdr;
    private String[] imdr;
    private boolean[] aendertpersonenfeld;
    private boolean[] aendertinventarfeld;
    
    /** gibt an, ob man mit der Person interaktiv reden kann */
    public boolean interaktiv() {
        return interaktivvar;
    }

    /** gibt die Standardantword dieser Person aus */
    public String antwortAusgeben() {
        return antwort;
    }
    
    /** gibt die Antwort zu einer speziellen Frage aus */
    public String antwortAusgeben(int antwortnummer) {
        return antworten[--antwortnummer];
    }
    
    /** gibt an, ob die Person eine Frage mit einer bestimmten
     * Nummer beantworten kann */
    public boolean hatAntwort(int antwortnummer) {
        return !antworten[--antwortnummer].equals("");
    }
    
    /** gibt an, ob die Person bei Stellen einer bestimmten
     * Frage das Inventar ndert */
    public boolean aendertInventar(int antwortnummer) {
        return aendertinventarfeld[--antwortnummer];
    }

    /** wird benutzt, damit eine nderung nicht immer und immer
     * wieder eintritt */
    public void hatInventarGeaendert(int antwortnummer) {
        aendertinventarfeld[--antwortnummer] = false;
    }
        
    /** gibt an, ob die Person bei Stellen einer bestimmten
     * Frage die Personenliste ndert */
    public boolean aendertPersonen(int antwortnummer) {
        return aendertpersonenfeld[--antwortnummer];
    }
    
    /** wird benutzt, damit eine nderung nicht immer und immer
     * wieder eintritt */
    public void hatPersonenGeaendert(int antwortnummer) {
        aendertpersonenfeld[--antwortnummer] = false;
    }
    
    /** Liste von hinzuzufgenden Personen beim Stellen einer
     * bestimmten Frage */
    public String[] PPDR (int antwortnummer) {
        return split(ppdr[--antwortnummer],";");
    }

    /** Liste von zu entfernenden Personen beim Stellen einer
     * bestimmten Frage */
    public String[] PMDR (int antwortnummer) {
        return split(pmdr[--antwortnummer],";");
    }
    
    /** Liste von hinzuzufgenden Inventargegenstnden beim Stellen einer
     * bestimmten Frage */    
    public String[] IPDR (int antwortnummer) {
        return split(ipdr[--antwortnummer],";");
    }

    /** Liste von zu entfernenden Inventargegenstnden beim Stellen einer
     * bestimmten Frage */        
    public String[] IMDR (int antwortnummer) {
        return split(imdr[--antwortnummer],";");
    }

    /** liest aus Dateien die Initialisierungsdaten fr deie Person ein,
     * die nicht ber den Super-Konstruktor eingelesen wurden */
    private void werteEinlesen() {
        antwort = new String(Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnisAusgeben()+nummerAusgeben()+"r.gpa")));
        for (int i=0;i<4;i++) {
            antworten[i] = Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnisAusgeben()+nummerAusgeben()+"r"+(i+1)+".gpa"));
            ppdr[i] = Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnisAusgeben()+nummerAusgeben()+"pp"+(i+1)+".gpa"));
            pmdr[i] = Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnisAusgeben()+nummerAusgeben()+"pm"+(i+1)+".gpa"));
            ipdr[i] = Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnisAusgeben()+nummerAusgeben()+"ip"+(i+1)+".gpa"));
            imdr[i] = Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnisAusgeben()+nummerAusgeben()+"im"+(i+1)+".gpa"));
        }
    }
    
    /** Wertet den in werteEinlesen() gelesenen Attribut-String aus */
    private void attributeEinlesen() {
        try {
            interaktivvar = attribute.substring(0,1).equals("1");
        }
        catch (StringIndexOutOfBoundsException ungueltigeattributdatei) {
        }
        for (int i=0;i<4;i++) {
            aendertpersonenfeld[i] = ((!ppdr[i].equals(""))||(!pmdr[i].equals("")));
            aendertinventarfeld[i] = ((!ipdr[i].equals(""))||(!imdr[i].equals("")));
        }
    }
               
    public static void main(String[] args) {
    }
    
}
