/*
 * Raum.java
 *
 * Created on 24. April 2002, 21:46
 */

package gpa;
import java.util.Vector;

/**
 *
 * @author  andreas
 */
public class Raum {
    
    /** Creates a new instance of Raum */
    public Raum(int x, int y, int z, int pxmax, int pymax, int pzmax,int[][]raeume) {
        x_koordinate=x;
        y_koordinate=y;
        z_koordinate=z;
        xmax=pxmax;
        ymax=pymax;
        zmax=pzmax;
        koordinaten = new String(new Integer(x_koordinate).toString()+
                                 new Integer(y_koordinate).toString()+
                                 new Integer(z_koordinate).toString());
        vorhandeneraeume=raeume;
        werteEinlesen();
        inventar = new java.util.Vector();
        personen = new java.util.Vector();
        vektorAnlegen(gegenstandsliste,inventar,true);
        vektorAnlegen(personenliste,personen,false);
        richtungenErrechnen();
    }
    
    private String aktuellebeschreibung;
    private String richtungen;
    private String gegenstandsliste;
    private String personenliste;
    private int x_koordinate;
    private int y_koordinate;
    private int z_koordinate;
    private int xmax;
    private int ymax;
    private int zmax;
    private boolean varnorden;
    private boolean varsueden;
    private boolean varwesten;
    private boolean varosten;
    private boolean varoben;
    private boolean varunten;
    private String koordinaten;
    private int[][] vorhandeneraeume;
    private java.util.Vector inventar;
    private java.util.Vector personen;
    
    /** gibt einen dreistelligen String mit den Koordiaten des Raumes aus
     * Muster: XYZ , X: Stockwerk, Y: senkrechte Achse, Z: waagerechte Achse */
    public String koordinatenAusgeben() {
        return koordinaten;
    }
    
    /** gibt eine URL zurck, die auf das zum Raum gehrige Photo verweist */
    public java.net.URL bildName() {
        return (getClass().getResource("/data/photos/"+koordinaten+".jpg"));
    }
    
    /** gibt an, ob eine bestimmte Person interaktiv Antworten geben kann.
     * Wird die Person mit dem bergebenen Namen nicht gefunden,
     * gibt die Methode false zurck. */
    public boolean personInteraktiv(String name) {
        try {
            return ((Person)personen.get(positionFinden(name,personen))).interaktiv();
        }
        catch (ArrayIndexOutOfBoundsException nichtinliste) {
            return false;
        }
    }
    
    /** gibt an, ob man der Person mit dem angegebenen Namen
     * eine bestimmte Frage stellen kann */
    public boolean personHatAntwort(String name, int antwortnummer) {
        try {
            return ((Person)personen.get(positionFinden(name,personen))).hatAntwort(antwortnummer);
        }
        catch (ArrayIndexOutOfBoundsException nichtinliste) {
            return false;
        }
    }
            
    /** Initialisierungswerte aus Dateien einlesen,
     * es findet noch keine Weiterverarbeitung statt */
    private void werteEinlesen() {
        aktuellebeschreibung = new String(Datei.inhaltAusgeben((getClass().getResource("/data/raum/"+koordinaten+"b.gpa"))));
        richtungen = new String(Datei.inhaltAusgeben((getClass().getResource("/data/raum/"+koordinaten+"r.gpa"))));
        gegenstandsliste = new String(Datei.inhaltAusgeben(getClass().getResource("/data/raum/"+koordinaten+"i.gpa")));
        personenliste = new String(Datei.inhaltAusgeben(getClass().getResource("/data/raum/"+koordinaten+"p.gpa")));
    }
    
    /** errechnet ber verschiedene Unterfunktionen die Richtungen,
     * in die man von diesem Raum aus gehen kann */
    private void richtungenErrechnen() {
        varnorden = (raumda(0,1,0)&&richtung(0));
        varsueden = (raumda(0,-1,0)&&richtung(1));
        varwesten = (raumda(0,0,-1)&&richtung(2));
        varosten = (raumda(0,0,1)&&richtung(3));
        varoben = (raumda(1,0,0)&&richtung(4));
        varunten = (raumda(-1,0,0)&&richtung(5));        
    }
    
    /** stellt fest, ob in einer bestimmten Richtung noch win weiterer Raum
     * liegt. Ist kein benachbarter Raum in dieser Richtung vorhanden,
     * wird per Rekursion in diese Richtung weitergesucht, bis ein Raum
     * gefunden wird (Erfolg) oder das Ende der Karte erreicht ist (Mierfolg) */
    private boolean raumda(int xaendern, int yaendern, int zaendern) {
        if (innerhalbderkarte(x_koordinate,y_koordinate,z_koordinate,xaendern,yaendern,zaendern)) {
             for (int j=0;j<vorhandeneraeume.length;j++) {
                if ((vorhandeneraeume[j][0]==(x_koordinate+xaendern)) &&
                    (vorhandeneraeume[j][1]==(y_koordinate+yaendern)) &&
                    (vorhandeneraeume[j][2]==(z_koordinate+zaendern))) {
                    return true;
                }
            }
            if (raumda(Zahl.inkrement(xaendern),Zahl.inkrement(yaendern),Zahl.inkrement(zaendern))) {
                return true;
            }
        }
        return false;
    }
    
    /** stellt fr einen Satz Koordinaten und eine Richtungsnderung fest,
     * ob der gesuchte Raum noch innerhalb der vorgegebenen Karte liegt */
    private boolean innerhalbderkarte(int x_koordinate, int y_koordinate, int z_koordinate, int xaendern, int yaendern, int zaendern) {
        return (((xaendern<0)&& ((x_koordinate+xaendern)>=0)) ||
                ((xaendern>0) && ((x_koordinate+xaendern)<=(xmax-1))) ||
                ((yaendern<0)&& ((y_koordinate+yaendern)>=0)) ||
                ((yaendern>0) && ((y_koordinate+yaendern)<=(ymax-1))) ||
                ((zaendern<0)&& ((z_koordinate+zaendern)>=0)) ||
                ((zaendern>0) && ((z_koordinate+zaendern)<=(zmax-1))));
    }
    
    /** verarbeitet die Richtungsangaben, die aus der Datei in werteEinlesen()
     * ausgelesen wurden. Es gibt sechs Angaben fr sechs Richtungen:
     * Norden, Sden, Westen, Osten, Oben, Unten */
    private boolean richtung(int getesteterichtung) {
        try {
            switch (getesteterichtung) {
                case 0: return (richtungen.substring(0,1).equals("1"));
                case 1: return (richtungen.substring(1,2).equals("1"));
                case 2: return (richtungen.substring(2,3).equals("1"));
                case 3: return (richtungen.substring(3,4).equals("1"));
                case 4: return (richtungen.substring(4,5).equals("1"));
                case 5: return (richtungen.substring(5,6).equals("1"));
                default: return false;
            }
        }
        catch (StringIndexOutOfBoundsException ungueltigerichtungsdatei) {
            return false;
        }
    }

    /** Legt den Inventar- oder Personenvektor an, je nach dem, wie der
     * Parameter ioderp gesetzt ist. Die Methode geht die vorhandene Liste
     * mit hinzuzufgenden Objekten der Reihe nach durch und fgt alle
     * in den Vektor ein. */
    private void vektorAnlegen(String objektliste,java.util.Vector objektvektor,boolean ioderp) {
        java.util.StringTokenizer puffer = new java.util.StringTokenizer(objektliste,";");
        String[] objekte = new String[puffer.countTokens()];
        int max=puffer.countTokens();
        for (int i=0;i<max;i++) {
            objekte[i]=puffer.nextToken();
        }
        for (int i=0;i<objekte.length;i++) {
            try {
                Objekt tmp;
                if (ioderp) {
                    tmp = new Inventargegenstand(new Integer(objekte[i]).intValue());
                }
                else {
                    tmp = new Person(new Integer(objekte[i]).intValue());
                }
            objektvektor.add(tmp);
            }
            catch (NumberFormatException keineZahl) {
            }
        }
    }
        
    /** findet zu einem Gegenstandsnamen oder einem Personennamen die 
     * zugehrige Nummer. Wird keine bereinstimmung gefunden, wirft
     * die Methode eine NullPointerException */
    private int nummerFinden(String name, java.util.Vector objekte) throws NullPointerException {
        for (int i=0;i<objekte.size();i++) {
            if (((Objekt)objekte.get(i)).nameAusgeben().equals(name)) {
                return ((Objekt)objekte.get(i)).nummerAusgeben();
            }
        }
        throw new NullPointerException();
    }
    
    /** findet eine Nummer zu einem Namen, sowohl fr Gegenstnde
     * als auch fr Personen. Erst wird nach einem Gegenstand gesucht,
     * dann nach einer Person. Wird beides nicht gefunden, wirft
     * die Methode eine NullPointerException */
    public int objektNummerFinden(String name) throws NullPointerException {
        try {
            return nummerFinden(name,inventar);
        }
        catch (NullPointerException keingegenstand) {
            return nummerFinden(name,personen);
        }
    }
    
    /** findet die passende Position im Vektor zu einer gegebenen 
     * Objektnummer oder wirft eine Exception */
    public int positionFinden(int nummer, java.util.Vector objekte) throws ArrayIndexOutOfBoundsException {
        for (int i=0;i<objekte.size();i++) {
            if (((Objekt)objekte.get(i)).nummerAusgeben()==nummer) {
                return i;
            }
        }
        throw new ArrayIndexOutOfBoundsException();
    }
    
    /** findet die passende Position im Vektor zu einem gegebenen
     * Objektnamen oder wirft eine Exception */
    public int positionFinden(String name, java.util.Vector objekte) throws ArrayIndexOutOfBoundsException {
        try {
            for (int i=0;i<objekte.size();i++) {
                if (((Objekt)objekte.get(i)).nummerAusgeben()==objektNummerFinden(name)) {
                    return i;
                }
            }
        }
        catch (NullPointerException nullpointerfehler) {
        }
        throw new ArrayIndexOutOfBoundsException();
    }
    
    /** Fgt neue Objekte in einen Vektor ein und lscht alte heraus,
     * es werden der zu bearbeitende Vektor, je eine Liste mit
     * neuen und alten Elementen und ein Parameter, der aussagt, ob
     * Inventargegenstnde oder Personen eingefgt werden sollen,
     * bergeben. */
    private void objektVektorAendern(java.util.Vector objekte,String[] neueobjekte,String[] entfernteobjekte,boolean ioderp) {
        for (int i=0;i<neueobjekte.length;i++) {
            try {
                Objekt neuesobjekt;
                if (ioderp) {
                    neuesobjekt = new Inventargegenstand(new Integer(neueobjekte[i]).intValue());
                }
                else {
                    neuesobjekt = new Person(new Integer(neueobjekte[i]).intValue());
                }
                objekte.add(neuesobjekt);
            }
            catch (NumberFormatException keinezahl) {
            }
        }
        for (int k=0;k<entfernteobjekte.length;k++) {
            try {
                objekte.remove(positionFinden(new Integer(entfernteobjekte[k]).intValue(),objekte));
            }
            catch (ArrayIndexOutOfBoundsException gegenstandnichtimvektor) {
            }
            catch (NumberFormatException keinezahl) {
            }
        }
    }
    
    /** sucht nach einem Gegenstand, falls er mitgenommen werden
     * kann, lscht die Methode ihn aus ihrem Inventar und gibt
     * den Gegenstand zurck. Wird kein Gegenstand mit dem Namen
     * gefunden, oder kann der Gegenstand nicht mitgenommen werden,
     * wird eine Exception geworfen*/
    public Inventargegenstand gegenstandGeben(String name) throws NullPointerException {
        if (((Inventargegenstand)inventar.get(positionFinden(name,inventar))).mitnehmbar()) {
                Inventargegenstand tmp = (Inventargegenstand)inventar.get(positionFinden(name,inventar));
            try {
                inventar.remove(positionFinden(tmp.nummerAusgeben(),inventar));
            }
            catch (ArrayIndexOutOfBoundsException objektnichtiminventar) {
            }
            return tmp;
        }
        throw new NullPointerException();
    }
    
    /** fgt einen bergebenen Gegenstand ins Inventar ein */
    public void gegenstandNehmen(Inventargegenstand ding) {
        inventar.add(ding);
    }
    
    /** gibt die beschreibung des Raumes aus */
    public String beschreibungAusgeben() {
        return aktuellebeschreibung;
    }
    
    /** liefert ein Feld zurck, das alle Namen der vorhandenen
     * Objekte im bergebenen Vektor (Inventar oder Personen) enthlt */
    private String[] objekteAusgeben(java.util.Vector objekte) {
        String[] liste = new String[objekte.size()];
        for (int i=0;i<objekte.size();i++) {
            liste[i]=(((Objekt)(objekte.get(i))).nameAusgeben());
        }
        return liste;
    }
    
    /** gibt die Namen aller im Raum vorhandenen Personen aus */
    public String[] personenAusgeben() {
        return objekteAusgeben(personen);
    }
    
    /** gibt die Namen aller im Raum vorhanden Inventargegenstnde aus */
    public String[] inventarAusgeben() {
        return objekteAusgeben(inventar);
    }
    
    /** gibt die Namen aller im Raum vorhandenen Objekte,
     * sowohl die von Gegenstnden als auch die von Personen, aus */
    public String[] alleObjekteAusgeben() {
        String[] gegenstaende = objekteAusgeben(inventar);
        String[] leute = objekteAusgeben(personen);
        String[] objekte = new String[gegenstaende.length+leute.length];
        for (int i=0;i<gegenstaende.length;i++) {
            objekte[i]=gegenstaende[i];
        }
        for (int i=0;i<leute.length;i++) {
            objekte[i+gegenstaende.length]=leute[i];
        }
        return objekte;
    }
     
    /** gibt die Beschreibung einer untersuchten Person aus. Anders als 
     * bei Gegenstnden soll dadurch nicht das Inventar gendert werden,
     * dazu soll man mit Personen reden mssen */
    public String personenBeschreibungAusgeben(String name) {
        try {
            return ((Person)personen.get(positionFinden(name,personen))).beschreibungAusgeben();
        }
        catch (ArrayIndexOutOfBoundsException personnichtinliste) {
            return ("");
        }
    }
    
    /** wird beim Untersuchen eines Gegenstandes aufgerufen,
     * berprft, ob das Inventar des Raumes durch das Untersuchen
     * gendert werden mu, und liefert dann die Beschreibung
     * des Gegenstandes zurck. */
    public String inventarBeschreibungAusgeben(String name) {
        try {
            Inventargegenstand tmp = (Inventargegenstand)inventar.get(positionFinden(name,inventar));
            if (tmp.aendertInventar()) {
                tmp.hatInventarGeaendert();
                objektVektorAendern(inventar,tmp.inventarHinzu(),tmp.inventarEntfernt(),true);
            }
            if (tmp.aendertPersonen()) {
                tmp.hatPersonenGeaendert();
                objektVektorAendern(personen,tmp.personenHinzu(),tmp.personenEntfernt(),false);
            }
            return (tmp.beschreibungAusgeben());
        }
        catch (ArrayIndexOutOfBoundsException gegenstandnichtinliste) {
            return ("");
        }
    }
    
    /** sucht nach einer Standard-Antwort zu dem angegebenen Personen-
     * namen und gibt diese aus, bei Bedarf wird die Personenliste
     * hierbei gendert */
    public String reden(String name) {
        Person tmp = (Person)personen.get(positionFinden(name,personen));
        try {
            if (tmp.aendertInventar()) {
                tmp.hatInventarGeaendert();
                objektVektorAendern(inventar,tmp.inventarHinzu(),tmp.inventarEntfernt(),true);
            }
            if (tmp.aendertPersonen()) {
                tmp.hatPersonenGeaendert();
                objektVektorAendern(personen,tmp.personenHinzu(),tmp.personenEntfernt(),false);
            }
            return (tmp.antwortAusgeben());            
        }
        catch (ArrayIndexOutOfBoundsException personnichtinliste) {
            return ("");
        }
    }
    
    /** ber diese Methode kann man interaktiv mit Personen reden.
     * Es werden der Name der Person und die Nummer der gestellten
     * Frage bergeben, bei Bedarf wird das Inventar
     * oder die Personenliste gendert. */
    public String reden(int antwortnummer, String name) {
        Person tmp = (Person)personen.get(positionFinden(name,personen));
        try {
            if (tmp.aendertInventar(antwortnummer)) {
                tmp.hatInventarGeaendert(antwortnummer);
                objektVektorAendern(inventar,tmp.IPDR(antwortnummer),tmp.IMDR(antwortnummer),true);
            }
            if (tmp.aendertPersonen(antwortnummer)) {
                tmp.hatPersonenGeaendert(antwortnummer);
                objektVektorAendern(personen,tmp.PPDR(antwortnummer),tmp.PMDR(antwortnummer),false);
            }
            return (tmp.antwortAusgeben(antwortnummer));            
        }
        catch (ArrayIndexOutOfBoundsException personnichtinliste) {
            return ("");
        }
    }
    
    /** berprft, ob eine Person einen Gegenstand nehmen mchte
     * und ndert bei Bedarf das Rauminventar */
    public String geben(Inventargegenstand objekt, String personenname) {
        return ("Test");
    }
    
    /** liefert die Beschreibung eines Objektes zurck, falls
     * ein Gegenstand mit dem entsprechenden Namen gefunden wird,
     * wird dessen Beschreibung ausgegeben, wird keiner gefunden,
     * sucht die Methode weiter bei den Personen. Wird auch hier
     * keine bereinstimmung gefunden, gibt die Methode eine Standard-
     * Fehlermeldung zurck. */
    public String objektBeschreibungAusgeben(String objektname) {
        String tmp = new String (inventarBeschreibungAusgeben(objektname));
        if (!tmp.equals("")) {
            return tmp;
        }
        else {
            tmp = personenBeschreibungAusgeben(objektname);
            if (!tmp.equals("")) {
                return tmp;
            }
        }
        return ("Wo siehst Du das denn : "+objektname+" ?");
    }
    
    /** gibt an, ob man von diesem Raum aus in die
     * genannte Richtung weitergehen kann */
    public boolean norden() {
        return varnorden;
    }
    
    /** gibt an, ob man von diesem Raum aus in die
     * genannte Richtung weitergehen kann */
    public boolean sueden() {
        return varsueden;
    }
    
    /** gibt an, ob man von diesem Raum aus in die
     * genannte Richtung weitergehen kann */    
    public boolean westen() {
        return varwesten;
    }

    /** gibt an, ob man von diesem Raum aus in die
     * genannte Richtung weitergehen kann */
    public boolean osten() {
        return varosten;
    }

    /** gibt an, ob man von diesem Raum aus in die
     * genannte Richtung weitergehen kann */
    public boolean oben() {
        return varoben;
    }

    /** gibt an, ob man von diesem Raum aus in die
     * genannte Richtung weitergehen kann */
    public boolean unten() {
        return varunten;
    }

    public static void main(String[] args) {
    }
    
}