/*
 * Spieler.java
 *
 * Created on 26. April 2002, 17:50
 */

package gpa;

/**
 *
 * @author  andreas
 */
public class Spieler {
    
    /** Creates a new instance of Spieler */
    public Spieler(String name, int xmax, int ymax, int zmax, int xstart, int ystart, int zstart) {
        inventarEinlesen();
        spielername = new String(name);
        schule = new Schule(xmax,ymax,zmax,xstart,ystart,zstart);
    }
    
    private String spielername;
    private String gegenstandsliste;
    public Schule schule;
    public java.util.Vector inventar;
    
    /** gibt den Spielernamen aus */
    public String nameAusgeben() {
        return spielername;
    }
    
    /** ndert den Spielernamen */
    public void nameAendern(String neuername) {
        spielername = neuername;
    }
    
    /** liest bei der Initialisierung das Inventar ein,
     * das der Spieler von Beginn an bei sich hat */
    private void inventarEinlesen() {
        gegenstandsliste = new String(Datei.inhaltAusgeben(getClass().getResource("/data/meta/spielerinventar.gpa")));
        inventar = new java.util.Vector();
        java.util.StringTokenizer puffer = new java.util.StringTokenizer(gegenstandsliste,";");
        String[] gegenstaende = new String[puffer.countTokens()];
        int max=puffer.countTokens();
        for (int i=0;i<max;i++) {
            gegenstaende[i]=puffer.nextToken();
        }
        for (int i=0;i<gegenstaende.length;i++) {
            try {
                inventar.add(new Inventargegenstand((new Integer(gegenstaende[i])).intValue()));
            }
            catch (NumberFormatException keineZahl) {
            }
        }
    }
    
    /** Gibt ein Feld mit den Namen aller im Spielerinventar
     * vorhandenen Gegenstnde aus */
    public String[] inventarAusgeben() {
        String[] liste = new String[inventar.size()];
        for (int i=0;i<inventar.size();i++) {
            liste[i]=(((Inventargegenstand)(inventar.get(i))).nameAusgeben());
        }
        return liste;
    }
    
    /** von der GUI aufgerufene Funktion fr den "Untersuchen"-Befehl */
    public String untersuchen(String objektname) {
        return schule.aktuellerraum.objektBeschreibungAusgeben(objektname);
    }
    
    /** von der GUI aufgerufene Funktion, um einen Gegenstand aus
     * dem SPielerinventar zu untersuchen */
    public String inventaruntersuchen(String objektname) {
        for (int i=0;i<inventar.size();i++) {
            if (((Inventargegenstand)inventar.get(i)).nameAusgeben().equals(objektname)) {
                Inventargegenstand tmp = (Inventargegenstand)inventar.get(i);
                inventarVektorAendern(tmp.inventarHinzu(),tmp.inventarEntfernt());
                return tmp.beschreibungAusgeben();
            }
        }
        return ("Das hast Du doch gar nicht: "+objektname);
    }
    
    /** von der GUI aufgerufenen Funktion, um ein Objekt zu nehmen */
    public String nehmen(String objektname) {
        try {
            inventar.add(schule.aktuellerraum.gegenstandGeben(objektname));
            return ("Du hast folgen Gegenstand genommen: "+objektname);
        }
        catch (NullPointerException objektnichtmitnehmbar) {
            return ("Das kannst Du nicht mitnehmen: "+objektname);
        }
    }
    
    /** von der GUI aufgerudene Funktion, um ein Objekt in
     * einem Raum abzulegen */
    public String legen(String objektname) {
        for (int i=0;i<inventar.size();i++) {
            if (((Inventargegenstand)inventar.get(i)).nameAusgeben().equals(objektname)) {
                schule.aktuellerraum.gegenstandNehmen((Inventargegenstand)inventar.get(i));
                inventar.remove(i);
                return ("Du hast folgen Gegenstand abgelegt: "+objektname);
            }
        }
        return ("Den Gegenstand hat Du gar nicht: "+objektname);
    }
    
    /** von der GUI aufgerufene Funktion, um mit einer Person zu reden */
    public String reden(String personenname) {
        return schule.aktuellerraum.reden(personenname);
    }
    
    /** von der GUI aufgerufene Funktion, um mit einer Person interaktiv
     * zu reden */
    public String reden(int antwortnummer, String personenname) {
        return schule.aktuellerraum.reden(antwortnummer,personenname);
    }
    
    /** von der GUI aufgerufene Funktion, um einer im aktuellen Raum
     * vorhandenen Person einen Gegendtand aus dem Spielerinventar
     * zu geben. Gibt einen Text als Ergebnis zurck und verndert
     * das Inventar des aktuellen Raumes bei Bedarf */
    public String geben(String objektname, String personenname) {
        for (int i=0;i<inventar.size();i++) {
            if (((Inventargegenstand)inventar.get(i)).nameAusgeben().equals(objektname)) {
                String tmp = new String(schule.aktuellerraum.geben((Inventargegenstand)inventar.get(i),personenname));
                if (!tmp.equals("")) {
                    inventar.remove(i);
                    return (tmp);
                }
                else {
                    return ("Nein Danke");
                }
            }
        }
        return ("Das hast Du doch gar nicht: "+objektname);
    }
    
    /** findet den Index eines Inventargegenstandes im Vektor */
    public int positionFinden(int nummer) throws ArrayIndexOutOfBoundsException {
        for (int i=0;i<inventar.size();i++) {
            if (((Inventargegenstand)inventar.get(i)).nummerAusgeben()==nummer) {
                return i;
            }
        }
        throw new ArrayIndexOutOfBoundsException();
    }

    /** ndert das Inventar anhand der bergebenen Listen */
    private void inventarVektorAendern(String[] neueobjekte,String[] entfernteobjekte) {
        for (int i=0;i<neueobjekte.length;i++) {
            try {
                inventar.add(new Inventargegenstand(new Integer(neueobjekte[i]).intValue()));
            }
            catch (NumberFormatException keinezahl) {
            }
        }
        for (int k=0;k<entfernteobjekte.length;k++) {
            try {
                inventar.remove(positionFinden(new Integer(entfernteobjekte[k]).intValue()));
            }
            catch (ArrayIndexOutOfBoundsException gegenstandnichtimvektor) {
            }
            catch (NumberFormatException keinezahl) {
            }
        }
    }
    
    public static void main (String[] args) {
    }
    
}
